//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MRVCamera"
#pragma link "MRVCamRecorder"
#pragma link "MRVType"
#pragma link "MRVCamView"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  RVCamRecorder1->VideoAutoSize = true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  RVCamera1->DeviceType = rvdtDesktop;
  RVCamRecorder1->Active = false;
  RVCamera1->DesktopWindowHandle = (unsigned int)Form2->Handle;
  RVCamera1->PlayVideoStream();
  RVCamRecorder1->Active = true;
  Memo1->Lines->Add("Form: " + String (Form2->Width) + " x " + String (Form2->Height));
  Memo1->Lines->Add("Recorder: " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));
  Sleep (1000);               // Makes no difference
  Memo1->Lines->Add("Recorder: " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  RVCamera1->DeviceType = rvdtDesktop;
  RVCamRecorder1->Active = false;
  RVCamera1->DesktopWindowHandle = (unsigned int)Form2->Panel1->Handle;
  RVCamera1->PlayVideoStream();
  RVCamRecorder1->Active = true;
  Memo1->Lines->Add("Panel: " + String (Form2->Panel1->Width) + " x " + String (Form2->Panel1->Height));
  Memo1->Lines->Add("Recorder: " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));
  Sleep (1000);               // Makes no difference
  Memo1->Lines->Add("Recorder: " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  RVCamRecorder1->VideoAutoSize = true;
  RVCamRecorder1->Active = false;
  RVCamera1->DeviceType = rvdtWebCamera;
  RVCamera1->VideoDeviceIndex = 0;
  RVCamera1->PlayVideoStream();
  RVCamRecorder1->Active = true;
  Sleep (1000);               // This works

  TRVVideoResolution res = RVCamera1->VideoResolution;

  Memo1->Lines->Add("Camera: " + String (
                                 res == rvDefault ? "Default" :                // How to get the actual size???
                                 res == rv160_120 ? "160 x 120" :
                                 res == rv320_240 ? "320 x 240" :
                                 res == rv640_480 ? "640 x 480" :
                                 res == rv1024_768 ? "1024 x 768" :
                                 res == rv1280_720 ? "1280 x 720" :
                                 res == rv1900_1280 ? "1900 x 1280" : "???")); // There must be an easier way!?

  Memo1->Lines->Add("Recorder: " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  Memo1->Lines->Add("Recorder (B): " + String (RVCamRecorder1->VideoWidth) + " x " + String (RVCamRecorder1->VideoHeight));

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  Form2->Show();

}
//---------------------------------------------------------------------------
